/*******************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only
* intended for use with Renesas products. No other uses are authorized. This
* software is owned by Renesas Electronics Corporation and is protected under
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
* AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software
* and to discontinue the availability of this software. By using this software,
* you agree to the additional terms and conditions found by accessing the
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2013 Renesas Electronics Corporation. All rights reserved.
*******************************************************************************/
/*******************************************************************************
* File Name   : init_spibsc_init2_section.c
* $Rev: $
* $Date::                           $
* Description : Initialize section
*******************************************************************************/

/******************************************************************************
Includes <System Includes> , gProject Includesh
******************************************************************************/
#include "r_typedefs.h"

#pragma arm section code   = "CODE_SPIBSC_INIT1"
#pragma arm section rodata = "CONST_SPIBSC_INIT1"
#pragma arm section rwdata = "DATA_SPIBSC_INIT1"
#pragma arm section zidata = "BSS_SPIBSC_INIT1"

/******************************************************************************
Typedef definitions
******************************************************************************/

/******************************************************************************
Macro definitions
******************************************************************************/


/******************************************************************************
Imported global variables and functions (from other files)
******************************************************************************/
extern uint32_t Load$$LR$$LOAD_MODULE3$$Base;
extern uint32_t Load$$LR$$LOAD_MODULE3$$Length;
extern uint32_t Image$$CODE_SPIBSC_INIT2$$Base;


/******************************************************************************
Exported global variables and functions (to be accessed by other files)
******************************************************************************/


/******************************************************************************
Private global variables and functions
******************************************************************************/

/******************************************************************************
* Function Name: init_spibsc_init2_section
* Description  : The initialization function of the section.
* Arguments    : none
* Return Value : none
******************************************************************************/
void init_spibsc_init2_section(void)
{
    int_t i,loop_num;
    uint32_t *src,*dst;
    uint32_t load_base;
    uint32_t exec_base;
    uint32_t region_size;

    /* initialization of LOAD_MODULE3 section */
    load_base   = (uint32_t)&Load$$LR$$LOAD_MODULE3$$Base;
    exec_base   = (uint32_t)&Image$$CODE_SPIBSC_INIT2$$Base;
    region_size = (uint32_t)&Load$$LR$$LOAD_MODULE3$$Length;

    src = (uint32_t *)load_base;
    dst = (uint32_t *)exec_base;
    loop_num = ((region_size + 3) / (sizeof(uint32_t)));

    for(i=0;i<loop_num;i++)
    {
        *dst++ = *src++;
    }
}
/* End of File */
